//package uk.ac.cf.spring.demo;
//
//import com.fasterxml.jackson.databind.ObjectMapper;
//import org.junit.jupiter.api.BeforeEach;
//import org.junit.jupiter.api.Test;
//import org.mockito.InjectMocks;
//import org.mockito.Mock;
//import org.mockito.MockitoAnnotations;
//import org.springframework.http.MediaType;
//import org.springframework.test.web.servlet.MockMvc;
//import org.springframework.test.web.servlet.setup.MockMvcBuilders;
//import uk.ac.cf.spring.demo.user.User;
//import uk.ac.cf.spring.demo.user.UserRepository;
//import uk.ac.cf.spring.demo.user.controller.RegistrationController;
//
//import static org.mockito.ArgumentMatchers.any;
//import static org.mockito.Mockito.*;
//import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.post;
//import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.status;
//import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.jsonPath;
//
//class RegistrationTest {
//
//    private MockMvc mockMvc;
//
//    @Mock
//    private UserRepository userRepository;
//
//    @InjectMocks
//    private RegistrationController registrationController;
//
//    private ObjectMapper objectMapper;
//
//    @BeforeEach
//    void setUp() {
//        MockitoAnnotations.openMocks(this);
//        mockMvc = MockMvcBuilders.standaloneSetup(registrationController).build();
//        objectMapper = new ObjectMapper();
//    }
//
//    @Test
//    void testRegisterUser_Success() throws Exception {
//        // Create a new user
//        User user = new User();
//        user.setUsername("testuser");
//        user.setEmail("testuser@example.com");
//
//        // Mock the repository save method
//        when(userRepository.existsByUsername(any(String.class))).thenReturn(false);
//        when(userRepository.existsByEmail(any(String.class))).thenReturn(false);
//
//        // Perform the POST request to register the user
//        mockMvc.perform(post("/api/users/register")
//                        .contentType(MediaType.APPLICATION_JSON)
//                        .content(objectMapper.writeValueAsString(user)))
//                .andExpect(status().isOk())
//                .andExpect(jsonPath("$.message").value("Registration successful"));
//
//        // Verify that save() was called once on the repository
//        verify(userRepository, times(1)).save(any(User.class));
//    }
//
//    @Test
//    void testRegisterUser_UsernameExists() throws Exception {
//        // Create a new user
//        User user = new User();
//        user.setUsername("testuser");
//        user.setEmail("testuser@example.com");
//
//        // Mock the repository to return true for existing username
//        when(userRepository.existsByUsername(any(String.class))).thenReturn(true);
//
//        // Perform the POST request to register the user
//        mockMvc.perform(post("/api/users/register")
//                        .contentType(MediaType.APPLICATION_JSON)
//                        .content(objectMapper.writeValueAsString(user)))
//                .andExpect(status().isBadRequest())
//                .andExpect(jsonPath("$.message").value("Username already exists"));
//
//        // Verify that save() was not called
//        verify(userRepository, times(0)).save(any(User.class));
//    }
//
//    @Test
//    void testRegisterUser_EmailExists() throws Exception {
//        // Create a new user
//        User user = new User();
//        user.setUsername("newuser");
//        user.setEmail("testuser@example.com");
//
//        // Mock the repository to return true for existing email
//        when(userRepository.existsByEmail(any(String.class))).thenReturn(true);
//
//        // Perform the POST request to register the user
//        mockMvc.perform(post("/api/users/register")
//                        .contentType(MediaType.APPLICATION_JSON)
//                        .content(objectMapper.writeValueAsString(user)))
//                .andExpect(status().isBadRequest())
//                .andExpect(jsonPath("$.message").value("Email already exists"));
//
//        // Verify that save() was not called
//        verify(userRepository, times(0)).save(any(User.class));
//    }
//}
//
